/***********************************************************************
*
* Copyright (c) 2021-2022 Barbara Geller and Ansel Sermersheim
*
* This example is free software, released under the BSD 2-Clause license.
* For license details refer to LICENSE provided with this project.
*
* CopperSpice is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* https://opensource.org/licenses/BSD-2-Clause
*
***********************************************************************/

#include <QtCore>
#include <QtGui>

class MainWindow : public QWidget
{
 public:
   MainWindow();
};

MainWindow::MainWindow()
{
   setMinimumSize(600, 350);

   QTabWidget *tabWidget = new QTabWidget();

   QWidget *tab1 = new QWidget();
   tabWidget->addTab(tab1, "Sandwich");

   QRadioButton *rb1_t1 = new QRadioButton{"Rye Bread"};
   QRadioButton *rb2_t1 = new QRadioButton{"Sourdough"};
   QRadioButton *rb3_t1 = new QRadioButton{"Whole Wheat"};

   QCheckBox *cb1_t1  = new QCheckBox{"Chicken"};
   QCheckBox *cb2_t1  = new QCheckBox{"Mushroom"};
   QCheckBox *cb3_t1  = new QCheckBox{"Pastrami"};
   QCheckBox *cb4_t1  = new QCheckBox{"Roast Turkey"};

   QCheckBox *cb5_t1  = new QCheckBox{"Avocado"};
   QCheckBox *cb6_t1  = new QCheckBox{"Grilled Onions"};
   QCheckBox *cb7_t1  = new QCheckBox{"Tomatoes"};
   QCheckBox *cb8_t1  = new QCheckBox{"Pickles"};

   QCheckBox *cb9_t1  = new QCheckBox{"Gouda"};
   QCheckBox *cb10_t1 = new QCheckBox{"Provolone"};
   QCheckBox *cb11_t1 = new QCheckBox{"Swiss Cheese"};

   QGridLayout *layout_t1 = new QGridLayout(tab1);
   layout_t1->setContentsMargins(20, 20, 20, 15);

   layout_t1->addWidget(rb1_t1,  0, 0);
   layout_t1->addWidget(rb2_t1,  1, 0);
   layout_t1->addWidget(rb3_t1,  2, 0);

   layout_t1->addWidget(cb1_t1,  0, 1);
   layout_t1->addWidget(cb2_t1,  1, 1);
   layout_t1->addWidget(cb3_t1,  2, 1);
   layout_t1->addWidget(cb4_t1,  3, 1);

   layout_t1->addWidget(cb5_t1,  0, 2);
   layout_t1->addWidget(cb6_t1,  1, 2);
   layout_t1->addWidget(cb7_t1,  2, 2);
   layout_t1->addWidget(cb8_t1,  3, 2);

   layout_t1->addWidget(cb9_t1,  0, 3);
   layout_t1->addWidget(cb10_t1, 1, 3);
   layout_t1->addWidget(cb11_t1, 2, 3);

   layout_t1->addItem(new QSpacerItem(0, 0, QSizePolicy::Expanding, QSizePolicy::Expanding), 4, 0, 1, 4);

   //
   QWidget *tab2 = new QWidget();
   tabWidget->addTab(tab2, "Salad");

   QRadioButton *rb1_t2 = new QRadioButton{"Carrot Salad"};
   QRadioButton *rb2_t2 = new QRadioButton{"Mixed Greens"};
   QRadioButton *rb3_t2 = new QRadioButton{"Pasta Primavera"};
   QRadioButton *rb4_t2 = new QRadioButton{"Potato Salad"};
   QRadioButton *rb5_t2 = new QRadioButton{"Tabbouleh"};

   QVBoxLayout *layout_t2 = new QVBoxLayout(tab2);
   layout_t2->setContentsMargins(20, 20, 20, 15);

   layout_t2->addWidget(rb1_t2);
   layout_t2->addWidget(rb2_t2);
   layout_t2->addWidget(rb3_t2);
   layout_t2->addWidget(rb4_t2);
   layout_t2->addWidget(rb5_t2);
   layout_t2->addStretch();

   //
   QWidget *tab3 = new QWidget();
   tabWidget->addTab(tab3, "Dessert");

   QRadioButton *rb1_t3 = new QRadioButton{"Cheesecake"};
   QRadioButton *rb2_t3 = new QRadioButton{"Lemon Bar"};
   QRadioButton *rb3_t3 = new QRadioButton{"Tiramisu"};
   QRadioButton *rb4_t3 = new QRadioButton{"Chocolate Chip"};
   QRadioButton *rb5_t3 = new QRadioButton{"Oatmeal Raisin"};

   QGroupBox *gb_d1 = new QGroupBox{"Dessert"};
   QVBoxLayout *layout_d1 = new QVBoxLayout(gb_d1);
   layout_d1->addWidget(rb1_t3);
   layout_d1->addWidget(rb2_t3);
   layout_d1->addWidget(rb3_t3);

   QGroupBox *gb_d2 = new QGroupBox{"Cookie"};
   QVBoxLayout *layout_d2 = new QVBoxLayout(gb_d2);
   layout_d2->addWidget(rb4_t3);
   layout_d2->addWidget(rb5_t3);
   layout_d2->addStretch();

   QGridLayout *layout_t3 = new QGridLayout(tab3);
   layout_t3->setContentsMargins(20, 20, 20, 15);

   layout_t3->addWidget(gb_d1, 0, 0);
   layout_t3->addWidget(gb_d2, 0, 1);
   layout_t3->addItem(new QSpacerItem(0, 0, QSizePolicy::Expanding, QSizePolicy::Expanding), 1, 0, 1, 2);

   //
   QPushButton *pb_1 = new QPushButton();
   pb_1->setText("Close");

   QHBoxLayout *layout = new QHBoxLayout();
   layout->addStretch();
   layout->addWidget(pb_1);
   layout->addStretch();

   QVBoxLayout *layoutMain = new QVBoxLayout(this);
   layoutMain->setContentsMargins(45, 35, 45, 15);

   layoutMain->addWidget(tabWidget);
   layoutMain->addSpacing(15);
   layoutMain->addLayout(layout);

   connect(pb_1, &QPushButton::clicked, this, &QWidget::close);
}

int main(int argc, char *argv[])
{
   QApplication app(argc, argv);

   MainWindow *window = new MainWindow();
   window->show();

   return app.exec();
}